#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
# -----------------------------------------------------------------------------------------------
# THIS PLUGIN WAS DEVELOPED AND TESTED UNDER WINDOWS VISTA ONLY AND MAY OR MAY NOT WORK ON A MAC. 
# -----------------------------------------------------------------------------------------------
#    Name:	Project Beam
#      By:	sdmitch
#   Usage:	Connect two points with a beam of defined shape
#		 Note:	Create a face representing the cross-section of the disired beam.  Add an edge to 
#						define the direction and length of the beam.  Pre-select them and execute plugin.
#    Date:	Jan 2012
#------------------------------------------------------------------------------------------------
#
require 'Sketchup'
#
if not file_loaded?(File.basename(__FILE__))
    UI.menu('Plugins').add_item('Project Beam') { SDMITCH.project_beam }
	 file_loaded(File.basename(__FILE__))
end
#
module SDMITCH
	def self.project_beam
		mod = Sketchup.active_model
		ent = mod.entities
		sel = mod.selection
		if !sel.empty?
			face=nil;edge=nil;sp=[];ep=[]
			sel.each{|e|
				face=e if e.class==Sketchup::Face
				edge=e if e.class==Sketchup::Edge && e.faces.length==0
			}
			if face && edge
				mod.start_operation "Project Beam"
				grp = ent.add_group face;ge=grp.entities
				sp=face.vertices;sp.collect!{|v| v.position}
				vec=edge.line[1];dis=edge.length
				for i in 0...sp.length
					ep[i]=sp[i].offset(vec,dis)
				end
				ge.add_face(ep)
				for i in 0...sp.length
					ge.add_face(sp[i-1],ep[i-1],ep[i],sp[i])
				end
				sel.clear;
				ent.erase_entities(edge)
				mod.commit_operation
			else
				UI.messagebox "Select a face and an edge"
			end
		else
			UI.messagebox "Select a face and an edge"
		end
	end
end